package com.afp.ordermanagement.config;

import com.mongodb.reactivestreams.client.MongoClient;
import com.mongodb.reactivestreams.client.MongoClients;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.core.ReactiveMongoTemplate;
import org.springframework.data.mongodb.core.SimpleReactiveMongoDatabaseFactory;

@Configuration
public class MongoConfig {
    @Value("${spring.data.mongodb.database}")
    public String databaseName;

    @Bean
    public SimpleReactiveMongoDatabaseFactory reactiveMongoDbFactory() {
        MongoClient mongoClient = MongoClients.create();
        return new SimpleReactiveMongoDatabaseFactory(mongoClient, databaseName);
    }

    @Bean
    public ReactiveMongoTemplate reactiveMongoTemplate() throws Exception {
        ReactiveMongoTemplate mongoTemplate = new ReactiveMongoTemplate(reactiveMongoDbFactory());
        return mongoTemplate;
    }
}
