package com.afp.ordermanagement.controller;

import com.afp.ordermanagement.model.OrderStatus;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;

public class AllOrdersRequestBody {
    public Pagination pagination;
    public Date date;
    public Search search;
    public Status status;

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Pagination {
        public int page, size;
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Date {
        public long start, end;
        public DateFilter filter;
    }

    public enum DateFilter {
        orderCreatedAt, orderUpdatedAt
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Search {
        public SearchBy by;
        public String query;
    }

    public enum SearchBy {
        id, customerEmailAddress, orderTrackingCode
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public class Status {
        public boolean received, fulfilled, cancelled;

        public List<OrderStatus> getTruthyStatuses() {
            List<OrderStatus> truthyStatuses = new ArrayList<>();
            if (received) truthyStatuses.add(OrderStatus.RECEIVED);
            if (fulfilled) truthyStatuses.add(OrderStatus.FULFILLED);
            if (cancelled) truthyStatuses.add(OrderStatus.CANCELLED);
            return truthyStatuses;
        }
    }
}